//+------------------------------------------------------------------+
//|                                             BrainTrendSignal.mqh |
//|                                                    2011, etrader |
//|                                             http://efftrading.ru |
//+------------------------------------------------------------------+
#property copyright "2011, etrader"
#property link      "http://efftrading.ru"
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
#property tester_indicator "BrainTrend1.ex5"
#include <Expert\ExpertSignal.mqh>
// wizard description start
//+------------------------------------------------------------------+
//| Description of the class                                         |
//| Title=Signal based on BrainTrend indicator                       |
//| Type=SignalAdvanced                                              |
//| Name=BRainTrend                                                  |
//| Class=CBrainTrendSignal                                          |
//| Page=                                                            |
//| Parameter=ATR_Period,int,7,ATR period                            |
//| Parameter=STO_Period,int,9,Stochastic period                     |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
// wizard description end
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  CBrainTrendSignal                                          |
//| :               |
//|             BrainTrend1 http://www.mql5.com/ru/code/391|
//+------------------------------------------------------------------+
class CBrainTrendSignal : public CExpertSignal
  {
private:
   CiCustom          m_indicator;      // - BrainTrend
   int               m_atr_period;     //  ATR  BrainTrend
   int               m_sto_period;     //    BrainTrend
public:
   virtual int       ShortCondition(); //    
   virtual int       LongCondition();  //    
   void CBrainTrendSignal()
     {
      m_used_series=USE_SERIES_OPEN+USE_SERIES_HIGH+USE_SERIES_LOW+USE_SERIES_CLOSE+USE_SERIES_TIME;
      m_atr_period = 7;
      m_sto_period = 9;
     }
   void ATR_Period( int passedperiod ){ m_atr_period = passedperiod;  }  //    ATR_Period
   void STO_Period( int passedperiod  ){ m_sto_period = passedperiod;  } //    STO_Period
   virtual bool      InitIndicators(CIndicators* indicators);            //  
   bool              InitBrainTrend(CIndicators* indicators);            // ,   BrainTrend
  };
//+------------------------------------------------------------------+
//|                                          |
//| INPUT:  indicators -              |
//| OUTPUT: true-, false                                 |
//| REMARK:                                                       |
//+------------------------------------------------------------------+
bool CBrainTrendSignal::InitIndicators(CIndicators *indicators)
  {
//---  
   if(indicators==NULL) return(false);
//---      
   if(!CExpertSignal::InitIndicators(indicators)) return(false);
//---     BrainTrend
   if(!InitBrainTrend(indicators)) return(false);
//--- ok
   return(true);
  }
//+------------------------------------------------------------------+
//|   BrainTrend                              |
//| INPUT: indicators -               |
//| OUTPUT: true-, false -                               |
//| REMARK:                                                       |
//+------------------------------------------------------------------+
bool CBrainTrendSignal::InitBrainTrend(CIndicators *indicators) 
  {
//---  
   if(indicators==NULL) return(false);
//---    
   if(!indicators.Add(GetPointer(m_indicator)))
     {
      printf(__FUNCTION__+":   ");
      return(false);
     }
//---   
   MqlParam parameters[3];
   parameters[0].type=TYPE_STRING;
   parameters[0].string_value="BrainTrend1.ex5";
   parameters[1].type=TYPE_INT;
   parameters[1].integer_value=m_atr_period;
   parameters[2].type=TYPE_INT;
   parameters[2].integer_value=m_sto_period;
//---     
   if(!m_indicator.Create(m_symbol.Name(),m_period,IND_CUSTOM,3,parameters))
     {
      printf(__FUNCTION__+":   ");
      return(false);
     }
//--- ok
   return(true);
  }
//+------------------------------------------------------------------+
//|                               |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CBrainTrendSignal::ShortCondition()
  {
//---      4  BrainTrend
//--- 0 - 
//--- 1 -  
//--- 2 -  
   if(m_indicator.GetData(4,1)==2) return(100);
//---      
   return(0);

  }
//+------------------------------------------------------------------+
//|                               |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CBrainTrendSignal::LongCondition()
  {
//---      4  BrainTrend
//--- 0 - 
//--- 1 -  
//--- 2 -  
   if(m_indicator.GetData(4,1)==1) return(100);
//---   
   return(0);
  }
//+------------------------------------------------------------------+